#!/usr/bin/python3
n, s = map(int, input().split())
stupci = input().split()

redci = []
for i in range(n):
    redci.append(input().split())

solved = dict()

def actual_len(s):
    if '#' in s and s.count('|') > 1:
        return len(s) - 2 + len('Concat()') + s.count('|') - 1
    else:
        return len(s) - 1 + s.count('|') - 1

def dp(stupac, pocetci):
    if pocetci in solved:
        return solved[pocetci]
    best = None
    goals = tuple(redci[i][stupac][pocetci[i]:] for i in range(n))

    def update(string, duljina, dodatak=None):
        if isinstance(duljina, int):
            novi_pocetci = tuple(p + duljina for p in pocetci)
        else:
            duljine = tuple(duljina)
            novi_pocetci = tuple(pocetci[r] + duljine[r] for r in range(n))
        ostatak = dp(stupac, novi_pocetci)
        if ostatak is not None:
            nonlocal best
            if dodatak:
                string = dodatak + '(' + string + ')'
            if sum(pocetci) == 0:
                kandidat = '#' + string + "|" + ostatak
            else:
                kandidat = string + "|" + ostatak
            if best is None or actual_len(kandidat) < actual_len(best) or\
                    actual_len(kandidat) == actual_len(best) and kandidat < best:
                best = kandidat

    # $var
    for j, varijabla in enumerate(stupci):
        if j == stupac: continue
        if all(goals[r].startswith(redci[r][j]) for r in range(n)):
            update('$' + varijabla, (len(redci[r][j]) for r in range(n)))
        if all(goals[r].startswith(redci[r][j].upper()) for r in range(n)):
            update('$' + varijabla,
                    (len(redci[r][j]) for r in range(n)), 'Upper')
        if all(goals[r].startswith(redci[r][j].lower()) for r in range(n)):
            update('$' + varijabla,
                    (len(redci[r][j]) for r in range(n)), 'Lower')

    # Const()
    lcs = min(len(g) for g in goals)
    while len(set(g[:lcs] for g in goals)) > 1:
        lcs -= 1
    for i in range(1, lcs + 1):
        #print(i, lcs)
        update(goals[0][:i], i, 'Const')

    # Substr()
    for j, varijabla in enumerate(stupci):
        if j == stupac: continue
        hi = min(len(redak[j]) for redak in redci)

        for i1 in range(hi):
            for i2 in range(i1 + 1, hi + 1):
                if not all(goals[r].startswith(redci[r][j][i1:i2])\
                        for r in range(n)):
                    break
                update('$' + varijabla + ', ' + str(i1) + ', ' + str(i2),
                        i2 - i1, 'Substr')

        for i1 in range(hi):
            for i2 in range(i1 + 1, hi + 1):
                if not all(goals[r].startswith(\
                        redci[r][j][i1:i2].upper()) for r in range(n)):
                    break
                update('Upper($' + varijabla + '), ' + str(i1) + ', ' + str(i2),
                        i2 - i1, 'Substr')

        for i1 in range(hi):
            for i2 in range(i1 + 1, hi + 1):
                if not all(goals[r].startswith(\
                        redci[r][j][i1:i2].lower()) for r in range(n)):
                    break
                update('Substr($' + varijabla + ', ' + str(i1) + ', ' +\
                        str(i2) + ')', i2 - i1, 'Lower')

    solved[pocetci] = best
    return best

f = int(input())
for it in range(f):
    stupac = stupci.index(input())
    solved.clear()
    solved[tuple(len(redak[stupac]) for redak in redci)] = ''
    sol = dp(stupac, tuple(0 for i in range(n)))[:-1].replace('#', '')
    if '|' in sol and sol.index('|') + 1 < len(sol):
        sol = 'Concat(' + ', '.join(sol.split('|')) + ')'
    print(sol)
